local winchmannHill = require("mods").requireFromPlugin("structs.winchmann_hill")

local excitingBrickGameBag = {}

excitingBrickGameBag._MT = {}

function excitingBrickGameBag._MT:__index(key)
    if self._bagHandler[key] then
        return self._bagHandler[key]
    end

    if excitingBrickGameBag._defaultValues[key] then
        return excitingBrickGameBag._defaultValues[key]
    end

    return rawget(self, key)
end

excitingBrickGameBag._defaultValues = {}

function excitingBrickGameBag._defaultValues:init(previews)
    self:fillBag()
    self:fillPreview()
end

function excitingBrickGameBag._defaultValues:fillPreview()
    while #self._piecePreviews < self._piecePreviewCount do
        table.insert(self._piecePreviews, self:nextPiece())
    end
end

function excitingBrickGameBag._defaultValues:fillBag()
    if self.defaultBag then
        self._bag = self:defaultBag()
    end
end

function excitingBrickGameBag._defaultValues:getPieceFromBag()
    if #self._bag == 0 then
        self:fillBag()
    end

    local index = self._randomState:random(#self._bag)

    return table.remove(self._bag, index)
end

function excitingBrickGameBag._defaultValues:pop()
    local res = table.remove(self._piecePreviews, 1)

    self:fillPreview()

    return res
end

-- Mode for random pieces
-- s1, s2, s3 for fixed seed bag
-- Piece buffer holds 10 next pieces, used for previews
function excitingBrickGameBag.createBag(mode, s1, s2, s3)
    local self = {}

    mode = mode or "seven_bag"

    self._mode = mode
    self._bagHandler = require("mods").requireFromPlugin("bags." .. mode)
    self._piecePreviewCount = 10
    self._piecePreviews = {}
    self._randomState = winchmannHill.createState(s1 or math.random(2147483647), s2 or math.random(2147483647), s3 or math.random(2147483647))

    local bag = setmetatable(self, excitingBrickGameBag._MT)

    bag:init()

    return bag
end

return excitingBrickGameBag