local matrixLib = require("mods").requireFromPlugin("matrix")
local utils = require("mods").requireFromPlugin("utils")

local excitingBrickGamePlayfield = {}

excitingBrickGamePlayfield._MT = {}

function excitingBrickGamePlayfield.createPlayfieldMatrix(width, height)
    return matrixLib.filled(" ", width, height)
end

function excitingBrickGamePlayfield.playfieldMatrixFromString(playfield, width, height)
    local matrix = matrixLib.filled(" ", width, height)

    local x = 0
    local lines = utils.split(playfield, "\n")

    for y, line in ipairs(lines) do
        x = 0

        for char in line:gmatch(".") do
            x = x + 1

            matrix:set(x, y, char)
        end
    end

    return matrix
end

function excitingBrickGamePlayfield.playfieldMatrixToString(matrix)
    local lines = {}
    local width, height = matrix:size()

    for y = 1, height do
        local line = {}

        for x = 1, width do
            table.insert(line, matrix:get(x, y, " "))
        end

        table.insert(lines, table.concat(line, ""))
    end

    return table.concat(lines, "\n")
end

function excitingBrickGamePlayfield.createPlayfield(width, height, visibleWidth, visibleHeight)
    local self = {}

    self._width = width or 10
    self._height = height or 40

    self._visibleWidth = visibleWidth or 10
    self._visibleHeight = visibleHeight or 20

    self._playfieldMatrix = excitingBrickGamePlayfield.createPlayfieldMatrix(self._width, self._height)

    return setmetatable(self, excitingBrickGamePlayfield._MT)
end

return excitingBrickGamePlayfield