local excitingBrickGameGarbageCalculator = require("mods").requireFromPlugin("exciting_brick_game.exciting_brick_game_garbage_calculator")
local excitingBrickGameMovement = require("mods").requireFromPlugin("exciting_brick_game.exciting_brick_game_piece_movement")

local garbageManager = {}

garbageManager._MT = {}

function garbageManager._MT:__index(key)
    if garbageManager._defaultValues[key] then
        return garbageManager._defaultValues[key]
    end

    return rawget(self, key)
end

garbageManager._defaultValues = {}

function garbageManager._defaultValues:calculateGarbage(linesCleared, tSpin, awardBackToBack, combo, allClear)
    return self._garbageCalculator:calculateGarbage(linesCleared, tSpin, awardBackToBack, combo, allClear)
end

function garbageManager._defaultValues:queueOutboundGarbage(linesCleared, tSpin, awardBackToBack, combo, allClear)
    local garbageLines = self:calculateGarbage(linesCleared, tSpin, awardBackToBack, combo, allClear)

    if self._garbageSendMode == "counter" then
        for i, lines in ipairs(self._inbound) do
            if garbageLines <= 0 then
                break
            end

            if garbageLines >= lines then
                self._inbound[i] = 0
                garbageLines = garbageLines - lines

            else
                self._inbound[i] = lines - garbageLines
                garbageLines = 0
            end
        end
    end

    if garbageLines > 0 then
        table.insert(self._outbound, garbageLines)
    end

    return garbageLines
end

function garbageManager._defaultValues:queueInboundGarbage(lines)
    if lines > 0 then
        table.insert(self._inbound, lines)
    end
end

function garbageManager._defaultValues:addGarbageToPlayfield(playfield, lines)
    excitingBrickGameMovement.addGarbageToPlayfield(playfield, lines, self._garbageSpawnMode)
end

function garbageManager._defaultValues:addAllInboundGarbageToPlayfield(playfield)
    while #self._inbound > 0 do
        self:addGarbageToPlayfield(playfield, table.remove(self._inbound))
    end
end

function garbageManager._defaultValues:getInboundGarbage()
    return self._inbound
end

function garbageManager._defaultValues:getOutboundGarbage()
    return self._outbound
end

function garbageManager.createGarbageManager(data)
    data = data or {}

    local self = {}

    self._garbageCalculator = excitingBrickGameGarbageCalculator.createGarbageCalculator(data)
    self._inbound = {}
    self._outbound = {}

    self._garbageSpawnMode = data.garbageSpawnMode or "well"
    self._garbageSendMode = data.garbageSendMode or "counter"

    return setmetatable(self, garbageManager._MT)
end

return garbageManager