local excitingBrickGameSimpleMenu = {}

excitingBrickGameSimpleMenu._defaultValues = {}

excitingBrickGameSimpleMenu._MT = {}

function excitingBrickGameSimpleMenu._MT:__index(key)
    if excitingBrickGameSimpleMenu._defaultValues[key] then
        return excitingBrickGameSimpleMenu._defaultValues[key]
    end

    return rawget(self, key)
end

function excitingBrickGameSimpleMenu._defaultValues:moveInMenu(direction)
    local filteredOptions = self:getDrawOptions()
    local nextIndex = math.max(math.min(self._index + direction, #filteredOptions), 1)

    self._index = nextIndex
end

function excitingBrickGameSimpleMenu._defaultValues:handleInputs(player, button, state)
    if state then
        if button == "hardDrop" then
            self:moveInMenu(-1)

        elseif button == "softDrop" then
            self:moveInMenu(1)

        elseif button == "rotateLeft" then
            self:activateSelected()
        end
    end
end

function excitingBrickGameSimpleMenu._defaultValues:activateSelected()
    local filteredOptions = self:getDrawOptions()
    local option = filteredOptions[self._index]

    if option.callback then
        option.callback()
    end

    self._index = 1
end

function excitingBrickGameSimpleMenu._defaultValues:getDrawOptions()
    local options = {}

    for _, option in ipairs(self._options) do
        if option.visible then
            if option.visible() then
                table.insert(options, option)
            end

        else
            table.insert(options, option)
        end
    end

    return options
end

function excitingBrickGameSimpleMenu.createMenu(options)
    local self = {}

    self._options = options or {}
    self._index = 1

    return setmetatable(self, excitingBrickGameSimpleMenu._MT)
end

return excitingBrickGameSimpleMenu
