local excitingBrickGameTheme = {}

excitingBrickGameTheme._MT = {}
excitingBrickGameTheme._defaultValues = {}

-- Prioritize functions from the theme, then sane defaults
function excitingBrickGameTheme._MT:__index(key)
    if self._theme and self._theme[key] then
        return self._theme[key]
    end

    if excitingBrickGameTheme._defaultValues[key] then
        return excitingBrickGameTheme._defaultValues[key]
    end

    return rawget(self, key)
end

function excitingBrickGameTheme.loadTheme(directory)
    local self = {}

    self._directory = directory
    self._theme = require("mods").requireFromPlugin(directory .. ".theme")

    if self._theme and self._theme.init then
        self._theme:init(directory)
    end

    return setmetatable(self, excitingBrickGameTheme._MT)
end

return excitingBrickGameTheme