local gameMode = {}

function gameMode:getInfoBoxes(game)
    local boxes = {}

    table.insert(boxes, "Mode - Marathon")
    table.insert(boxes, string.format("Lines - %s / %s", game._linesCleared, self._requiredLines))
    table.insert(boxes, string.format("Level - %s", game._level))
    table.insert(boxes, string.format("Time - %.02f", game._timeUnpaused))
    table.insert(boxes, string.format("Score - %s", game._score))

    return boxes
end

function gameMode:updateGame(dt, game)
    game:update(dt)

    local newLevel = self._initialLevel + math.floor(game._linesCleared / self._levelUpRate)

    if newLevel ~= game._level then
        -- TODO - Send level up event to game manager

        game:setLevel(newLevel)
    end

    if game._linesCleared >= self._requiredLines and not self._finished then
        self._finished = true
        game._paused = true
        game._pauseEnabled = false
    end
end

function gameMode:init(games, settings)
    self._finished = false
    self._requiredLines = settings.lines or 150
    self._levelUpRate = settings.levelUpRate or 10
    self._initialLevel = games[1]:getLevel()
end

return gameMode
