local gameMode = {}

function gameMode:getInfoBoxes(game)
    local boxes = {}

    table.insert(boxes, "Mode - Sprint")
    table.insert(boxes, string.format("Lines - %s / %s", game._linesCleared, self._requiredLines))
    table.insert(boxes, string.format("Score - %s", game._score))
    table.insert(boxes, string.format("Time - %.02f", game._timeUnpaused))

    return boxes
end

function gameMode:updateGame(dt, game)
    game:update(dt)

    if game._linesCleared >= self._requiredLines and not self._finished then
        self._finished = true
        game._paused = true
        game._pauseEnabled = false
    end
end

function gameMode:init(games, settings)
    self._requiredLines = settings.lines or 40
    self._finished = false
end

return gameMode
