local gameMode = {}

function gameMode:getInfoBoxes(game)
    local boxes = {}

    local timeLeft = math.max(self._timeLimit - game._timeUnpaused, 0)

    table.insert(boxes, "Mode - Ultra")
    table.insert(boxes, string.format("Lines - %s", game._linesCleared))
    table.insert(boxes, string.format("Score - %s", game._score))
    table.insert(boxes, string.format("Time - %6.2f", timeLeft))

    return boxes
end

function gameMode:updateGame(dt, game)
    game:update(dt)

    if game._timeUnpaused >= self._timeLimit then
        self._finished = true
        game._paused = true
        game._pauseEnabled = false
    end
end

function gameMode:init(games, settings)
    self._timeLimit = settings.timeLimit or 180
    self._finished = false
end

return gameMode
