local winchmannHill = {}

winchmannHill._MT = {}

function winchmannHill._MT:__index(key)
    if winchmannHill._defaultValues[key] then
        return winchmannHill._defaultValues[key]
    end

    return rawget(self, key)
end

winchmannHill._defaultValues = {}

function winchmannHill._defaultValues:randomFloat()
    self.s1 = 171 * self.s1 % 30269
    self.s2 = 172 * self.s2 % 30307
    self.s3 = 170 * self.s3 % 30323

    return (self.s1 / 30269 + self.s2 / 30307 + self.s3 / 30323) % 1
end

function winchmannHill._defaultValues:randomInRange(min, max)
    return min + math.floor(self:randomFloat() * (max - min + 1))
end

function winchmannHill._defaultValues:random(min, max)
    if min and max then
        return self:randomInRange(min, max)

    elseif min then
        return self:randomInRange(1, min)

    else
        return self:randomFloat()
    end
end

function winchmannHill.createState(s1, s2, s3)
    local self = {}

    self._type = "winchmann_hill"

    self.s1 = s1
    self.s2 = s2
    self.s3 = s3

    return setmetatable(self, winchmannHill._MT)
end

return winchmannHill